rm( list=ls() )   
set.seed(1)  
source("functions.R")

p=2
fct_code = function(x,beta) {
  #x: vector of n experimental conditions
  #beta: vector of two model parameters
  #RETURN: vector of code responses
  beta[1] + beta[2] * x
}

fct_H = function(x,beta) {
  #x: vector of n experimental conditions
  #beta: vector of two model parameters
  #RETURN: matrix of partial derivatives at beta (cf slide 10)
  #
  #TO COMPLETE
  #
}

fct_physical_system = function(x) {
  #x: vector of n experimental conditions
  #RETURN: vector of code responses
  -sin(pi*x/1.3)
}

sigma_m = 0.1

#Data
n=50
X = (1:n)/n   #vector of experimental conditions

y = #TO COMPLETE  #vector of n experimental results
beta_nom = c(1,1)  #
f_beta_nom = fct_code(X,beta_nom)
H = fct_H(X,beta_nom)

#A priori on beta
beta_prior = c(-0.6,0)
Q_prior = diag(c(0.36,0.36))

#Plot of the a priori parameters
n_cont = 100
X_cont = (1:n_cont)/n_cont
plot(X,y,type="p",col="black")
points(X_cont,fct_code(X_cont,beta_prior),type="l",col="blue")
points(X_cont,fct_physical_system(X_cont),type="l",col="black")

#Filling the covariance matrix (parameters given)
sigma = 1
l = 0.5
R = fct_cov_gauss(X,X,sigma,l)+sigma_m^2*diag(n)

#A posteriori distribution of beta
beta_post = fct_beta_post(beta_prior,Q_prior,H,R,y,f_beta_nom,beta_nom)
Q_post=fct_Q_post(Q_prior,H,R)

#Adding the a posteriori parameters on the plot
points(X_cont,fct_code(X_cont,beta_post),type="l",col="red")

#Computing conditional means and variances at points in X_cont
hat_phi_cont = X_cont
hat_sigma_2_cont = X_cont
for (i in 1:n_cont) {   #cf slide 73
  x_0 = X_cont[i]
  h_0 = #TO COMPLETE
  r_0 = #TO COMPLETE
  f_nom_x_0 = #TO COMPLETE
  f_nom = #TO COMPLETE
  C_0 = #TO COMPLETE
  hat_phi_cont[i] = fct_hat_phi(f_nom_x_0,h_0,beta_post,beta_nom,r_0,R,y,f_nom,H)
  hat_sigma_2_cont[i] = fct_hat_sigma_2(C_0,r_0,R,h_0,H,Q_prior)
}


#Adding the conditional means and variances on the plot
points(X_cont,hat_phi_cont,type="l",col="purple")
points(X_cont,hat_phi_cont+1.96*sqrt(hat_sigma_2_cont),type="l",col="green")
points(X_cont,hat_phi_cont-1.96*sqrt(hat_sigma_2_cont),type="l",col="green")





