####################################
# MODEL-FREE APPROACHES
####################################


source('TestFunctionsETICS.R')
library("sensitivity")


# fmodel = "welchetal92"; dimx <- 20; ns <- 100
# fmodel = "morretal06"; dimx <- 30; ns <- 100
# fmodel = "loepetal13"; dimx <- 10; ns <- 100
# fmodel = "linketal06dec"; dimx <- 10; ns <- 100
# fmodel = "moon10hdc2"; dimx <- 20; ns <- 100
# fmodel = "moon10hdc3"; dimx <- 20; ns <- 100
# fmodel = "soblev99"; dimx <- 20; ns <- 100
# fmodel = "ishigami"; dimx <- 3; ns <- 100
# fmodel = "gfunc"; dimx <- 20; ns <- 100
# fmodel = "meieretal09a"; dimx <- 200; ns <- 150
# fmodel = "meieretal09b"; dimx <- 80; ns <- 100
# fmodel = "meieretal09c"; dimx <- 80; ns <- 200
fmodel = "meieretal09d"; dimx <- 60; ns <- 100


####################
# DCOR selection
####################
X <- runif(ns*dimx)
dim(X) <- c(ns,dimx)
Y <- apply(X,1,fmodel)
Y <- as.matrix(Y)

SDCOR <- sensiHSIC(model = NULL, X, kernelX = "dcov", kernelY = "dcov",nboot=20)
resDCOR <- tell(SDCOR, Y)
plot(resDCOR)

####################
# HSIC selection
####################
X <- runif(ns*dimx)
dim(X) <- c(ns,dimx)
Y <- apply(X,1,fmodel)
Y <- as.matrix(Y)

SHSIC <- sensiHSIC(model = NULL, X, kernelX = "rbf", kernelY = "rbf",nboot=20)
resHSIC <- tell(SHSIC, Y)
plot(resHSIC)
